#include <iostream>
#define MAXN 100003
#define INF 1000000000
using namespace std;
typedef long long ll;
ll n;
ll arr[MAXN];
ll tree[MAXN * 8];
void build(ll v, ll l, ll r)
{
    if (l == r)
    {
        tree[v] = l;
        return;
    }
    build(v<<1, l, (l+r)>>1);
    build((v<<1)+1, ((l+r)>>1)+1, r);
    if (arr[tree[v<<1]] < arr[tree[(v<<1)+1]]) tree[v] = tree[v<<1];
    else tree[v] = tree[(v<<1)+1];
}
ll get(ll v, ll l, ll r, ll x, ll y)
{
    if (l > y || r < x) return INF;
    if (l >= x && r <= y) return tree[v];
    ll first = get(v<<1, l, (l+r)>>1, x, y);
    ll second = get((v<<1)+1, ((l+r)>>1)+1, r, x, y);
    if (first == INF) return second;
    if (second == INF) return first;
    if (arr[first] < arr[second]) return first;
    return second;
}
ll dp[MAXN];
ll rec(ll l, ll r)
{
    if (l > r || l < 1 || r > n) return 0;
    ll idx = get(1, 1, n, l, r);
    return max(max(rec(l, idx-1), rec(idx+1, r)), arr[idx] * (dp[r]-dp[l-1]));
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> arr[i];
    for (int i = 1; i <= n; i++)
        dp[i] = dp[i-1] + arr[i];
    build(1, 1, n);
    cout << rec(1, n) << endl;
}
