#include <iostream>
#include <stack>
#define MAXN 100003
#define INF 1000000000
using namespace std;
typedef long long ll;
ll n;
ll arr[MAXN];
ll dp[MAXN];
ll idx_l[MAXN];
ll idx_r[MAXN];
stack <ll> st;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> arr[i];
    for (int i = 1; i <= n; i++)
        dp[i] = dp[i-1] + arr[i];
    for (int i = 1; i <= n; i++)
    {
        while (!st.empty() && arr[i] < arr[st.top()])
            st.pop();
        if (st.empty()) idx_l[i] = 0;
        else idx_l[i] = st.top();
        st.push(i);
    }
    while (!st.empty())
        st.pop();
    for (int i = n; i >= 1; i--)
    {
        while (!st.empty() && arr[i] < arr[st.top()])
            st.pop();
        if (st.empty()) idx_r[i] = n+1;
        else idx_r[i] = st.top();
        st.push(i);
    }
    ll max_ans = 0;
    for (int i = 1; i <= n; i++)
    max_ans = max(max_ans, arr[i] * (dp[idx_r[i]-1]-dp[idx_l[i]]));
    cout << max_ans << endl;
}
