#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#define MAXN 128
#define MAXM 128
using namespace std;
int n, m;
vector <int> comb;
void gen(int pos, int num)
{
    if (pos == n * m + 1)
    {
        comb.push_back(num);
        return;
    }
    gen(pos+1, num * 2);
    gen(pos+1, num * 2 + 1);
}
int nxt[4*(MAXN*MAXM)];
int idx1(int x, int y)
{
    return (x-1)*m + y;
}
int idx2(int x, int y)
{
    if (x == 0)
        return 2 * n + 2 * m - y + 1;
    if (x == n+1)
        return n + y;
    if (y == 0)
        return x;
    if (y == m+1)
        return 2 * n + m - x + 1;
}
int main()
{
    cin >> n >> m;
    for (int i = 1; i <= 2 * (n + m); i++)
    {
        int curr_next;
        cin >> curr_next;
        nxt[i] = curr_next;
    }
    if (n * m <= 22)
    {
    gen(1, 0);
    int sz = comb.size();
    for (int t = 0; t < comb.size(); t++)
    {
        bool used[MAXN * MAXM];
        memset(used, 0, sizeof(used));
        int pos = m * n;
        while (comb[t])
        {
            used[pos] = comb[t] % 2;
            comb[t] /= 2;
            pos--;
        }
        bool can = 1;
        for (int i = 0; i <= n+1; i++)
            for (int j = 0; j <= m+1; j++)
            {
                int cnt = 0;
                if (i == 0)
                    cnt++;
                if (i == n+1)
                    cnt++;
                if (j == 0)
                    cnt++;
                if (j == m+1)
                    cnt++;
                if (cnt == 1)
                {
                    int x = i;
                    int y = j;
                    int dir;
                    if (x == 0)
                        dir = 4;
                if (y == 0)
                        dir = 1;
                    if (y == m+1)
                        dir = 3;
                    if (x == n+1)
                        dir = 2;
                    do
                    {
                        if (dir == 1)
                            y++;
                        if (dir == 2)
                            x--;
                        if (dir == 3)
                            y--;
                        if (dir == 4)
                            x++;
                        if (used[idx1(x, y)])
                        {
                            if (dir == 1)
                                dir = 2;
                            else if (dir == 2)
                                dir = 1;
                            else if (dir == 3)
                                dir = 4;
                            else if (dir == 4)
                                dir = 3;
                        }
                    }
                    while(x >= 1 && x <= n && y >= 1 && y <= m);
                    if (nxt[idx2(i, j)] != idx2(x, y))
                    {
                        can = 0;
                         break;
                    }
                }
            }
        if (can)
        {
            for (int i = 1; i <= n; i++)
            {
                for (int j = 1; j < m; j++)
                    cout << used[idx1(i, j)] << " ";
                cout << used[idx1(i, m)] << endl;
            }
            break;
        }
    }
    }
    else
        for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j < m; j++)
            cout << "1 ";
        cout << 1 << endl;
    }
}
/*
2 3
9
10
8
7
6
5
4
3
1
2
*/
