#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

short dp[200][200];
vector<short> v[26];

short binSearch(short x,short ind)
{
    short l,r,mid;

    l=-1;
    r=v[ind].size()-1;

    while(l!=r)
    {
        mid=(l+r+1)/2;

        if(v[ind][mid]>x)
            r=mid-1;
        else
            l=mid;
    }

    if(l==-1)return -1;

    return v[ind][l];
}

short solve(short l,short r)
{
    if(l==r)return 1;
    if(l>r)return 0;
    if(dp[l][r])return dp[l][r];

    short i,l2,r2;
    vector<short> :: iterator it;

    dp[l][r]=1;

    for(i=0;i<26;i++)
    {
        it=lower_bound(v[i].begin(),v[i].end(),l);
        if(it!=v[i].end() && *it<=r)
        {
            r2=binSearch(r,i);
            l2=*it;
            //cout<<l2<<" "<<r2<<" - "<<l<<" "<<r<<" i="<<i<<endl;
            if(l2!=r2)dp[l][r]=max(dp[l][r],(short)(solve(l2+1,r2-1)+2));
        }
    }

    return dp[l][r];
}

int main ()
{
    short t,i,k,j,p,p2;
    string s,res;

    //ios::sync_with_stdio(false);

    cin>>t;

    for(t;t>0;t--)
    {
        cin>>k>>s;

        for(i=0;i<s.size();i++)
        {
            v[s[i]-'a'].push_back(i);
        }

        //cout<<solve(0,s.size()-1)<<endl;

        if(solve(0,s.size()-1)+k>=s.size())
            res+="1";
        else
            res+="0";

        for(i=0;i<s.size();i++)
            v[i].clear();

        for(i=0;i<s.size();i++)
            for(j=0;j<s.size();j++)
                dp[i][j]=0;
    }

    cout<<res<<endl;

    return 0;
}
