#include<iostream>

using namespace std;

int link[401];
int link2[401];
bool table[101][101];
int where[101][101];
int n,m;
int up[101][101];
int t[101][101];

pair<int,int> find_intersection(int a,int b)
{
    int x,y;

    x=a;
    y=1;

    while(x>=1 && y<=m)
    {

        //cout<<x<<" -- "<<y<<endl;
        if(up[x][y]==a)
        {
            if(t[x][y]==b)
                return make_pair(x,y);
            x--;
        }
        else
        {
            if(up[x][y]==b)
                return make_pair(x,y);
            y++;
        }
    }

    return make_pair(-1,-1);
}

pair<int,int> swapLasers(int a,int b)
{
    pair<int,int> p=find_intersection(a,b);

    if(p.first==-1)
        return p;

    swap(up[p.first][p.second],t[p.first][p.second]);

    int x,y;

    x=p.first;
    y=p.second;

    if(up[x][y]==a)x--;
    else y++;

    while(x>=1 && y<=m)
    {
        if(up[x][y]==b)up[x][y]=a;
        else t[x][y]=a;

        if(up[x][y]==a)
            x--;
        else
            y++;
    }

    x=p.first;
    y=p.second;

    if(up[x][y]==b)x--;
    else y++;

    while(x>=1 && y<=m)
    {
        if(up[x][y]==a)up[x][y]=b;
        else t[x][y]=b;

        if(up[x][y]==b)
            x--;
        else
            y++;
    }

    return p;
}


int main ()
{
    int i,j,curr;
    pair<int,int> p;

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n>>m;

    for(i=1;i<=2*(n+m);i++)
        cin>>link[i];

    for(i=1;i<=(n+m);i++)
    {
        if(i<=n)
        {
            link2[i]=2*n+m+1-i;
            link2[2*n+m+1-i]=i;
        }
        else
        {
            link2[i]=2*m+3*n+1-i;
            link2[2*m+3*n+1-i]=i;
        }
    }

    for(i=1;i<=n;i++)
        for(j=1;j<=m;j++)
            t[i][j]=i;

    for(i=1;i<=n;i++)
        for(j=1;j<=m;j++)
            up[i][j]=j+n;

    for(i=1;i<=n;i++)
    {
        for(j=n+1;j<=n+m;j++)
        {
            if(link[j]!=link2[j])
            {
                p=swapLasers(min(link2[link[j]],j),max(link2[link[j]],j));
               // cout<<p.first<<" "<<j<<endl;
                if(p.first!=-1)
                {
                    table[p.first][p.second]=1;
                    swap(link2[j],link[j]);
                }
            }
        }
    }

    for(i=1;i<=n;i++)
    {
        for(j=1;j<m;j++)
            cout<<table[i][j]<<" ";
        cout<<table[i][j]<<"\n";
    }

    return 0;
}
