#include <iostream>
using namespace std;
long long n, m;
long long d[100][100];
long long h[100][2];
long long w[100][2];

long long check_h_l(long long t, long long p)
{
    for (int i = p; i < m; i++)
        if (d[t][i] == 1)return i;
    return -1;
}

long long check_h_r(long long t, long long p)
{
    for (int i = p; i >= 0; i--)
        if (d[t][i] == 1)return i;
    return -1;
}

long long check_w_r(long long t, long long p)
{
    for (int i = p; i >= 0; i--)
        if (d[i][t] == 1)return i;
    return -1;
}

long long check_w_l(long long t, long long p)
{
    for (int i = p; i < n; i++)
        if (d[i][t] == 1)return i;
    return -1;
}

void d0(long long t, long long p)
{
    //cout << t << " " << p << endl;
    if (t >= 1 && t <= n)
        if (p >= m + 2 * n + 1 && p <= 2 * m + 2 * n)
            d[t - 1][2 * n + 2 * m - p] = 1;

    if (t >= n + 1 && t <= m + n)
        if (p >= m + n + 1 && p <= m + 2 * n)
            {
                d[m + 2 * n - p][t - n - 1] = 1;
                //cout << "lel" << " " << t - n - 1 << " " << m + 2 * n - p <<endl;
            }

    if (t >= m + n + 1 && t <= m + n + n)
        if (p >= n + 1 && p <= m + n)
            d[t][n + m - p] = 1;

    if (t >= m + n + n + 1 && t <= m + n + m + n)
        if (p >= 0 && p <= n)
            d[p - 1][t] = 1;
}

void q(long long t, long long p)
{
    if (t >= 1 && t <= n)
        {
            if (p >= m + 2 * n + 1 && p <= 2 * m + 2 * n)
            {
                if (check_h_l(t - 1, p - m - n - n) != -1)
                {
                    d0(check_h_l(t - 1, p - m - n - n) + m + n + n + 1, p);
                    //cout << "*" << endl;
                }
                else d0(t, p);
            }
            else d0(t, p);
        }
        else if (t >= n + 1 && t <= m + n)
        {
            if (p >= m + n + 1 && p <= m + 2 * n)
            {
                //cout << "--" << endl;
                //if (w[][1] >= p - m - n)
                if (check_w_r(t - n - 1, p - m - n) != -1)
                    d0(check_w_r(t - n - 1, p - m - n) + 1, p);
                else d0(t, p);
            }
            else d0(t, p);
        }
        else if (t >= m + n + 1 && t <= m + n + n)
        {
            if (p >= n + 1 && p <= m + n)
            {
                //if (h[t - m - n - 1][1] <= p - n - 1)
                if (check_h_r(t - m - n - 1, p - n - 1) != -1)
                    d0(check_h_r(t - m - n - 1, p - n - 1) + m + n + 1, p);
                else d0(t, p);
            }
            else d0(t, p);
        }
        else if (t >= m + n + n + 1 && t <= m + n + m + n)
        {
            if (p >= 0 && p <= n)
            {
                //if (w[t - m - n - n - 1][0] <= p - 1)
                if (check_w_l(t - m - n - n - 1, p - 1) != -1)
                    d0(check_w_l(t - m - n - n - 1, p - 1) + m + n + n + 1, p);
                else d0(t, p);
            }
            else d0(t, p);
        }
}

void update()
{
    for (int i = 0; i < n; i++)
    {
        h[i][0] = h[i][1] = m * n * m * n;
        for (int j = 0; j < m; j++)
            if (d[i][j])
                h[i][0] = j;

        for (int j = m - 1; j >= 0; j--)
            if (d[i][j])
                h[i][1] = j;
    }

    for (int i = 0; i < m; i++)
    {
        h[0][i] = h[1][i] = m * n * m * n;
        for (int j = 0; j < n; j++)
            if (d[j][i])
                h[j][0] = j;

        for (int j = n - 1; j >= 0; j--)
            if (d[j][i])
                h[j][1] = j;
    }
}

void input()
{
    cin >> n >> m;

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            d[i][j] = 0;
    //long long t;
    long long p;

    for (long long t = 1; t <= m + n + m + n; t++)
    {
        cin >> p;
        update();
        q(t, p);



        update();
    }

    for (int i = 0; i < n; i++)
    {
        cout << d[i][0];
        for (int j = 1; j < m; j++)
            cout << " " << d[i][j];
        cout << endl;
    }

}

int main()
{
    input();


    return 0;

}
/*
/// down
for (t = 0; t < n; t++)
{
    long long p;
    cin >> p;
    if (p >= m + 2 * n + 1 && p <= 2 * m + 2 * n)d[t][2 * n + 2 * m - p] = 1;
}

for (int i = 0; i < n; i++)
{
    h[i][0] = h[i][1] = -1;
    for (int j = 0; j < m; j++)
        if (d[i][j])h[i][0] = j;

    for (int j = m - 1; j >= 0; j--)
        if (d[i][j])h[i][1] = j;
}

for (int i = 0; i < n; i++)
{
    cout << d[i][0];
    for (int j = 1; j < m; j++)
        cout << " " << d[i][j];
    cout << endl;
}

/// right
for (t = 0; t < m; t++)
{
    long long p;
    cin >> p;

    if (p >= m + n + 1 && p <= m + 2 * n)d[2 * n + m - p][t] = 1;
}

for (int i = 0; i < m; i++)
{
    h[0][i] = h[0][i] = -1;
    for (int j = 0; j < n; j++)
        if (d[j][i])h[j][0] = j;

    for (int j = n - 1; j >= 0; j--)
        if (d[j][i])h[j][i] = j;
}

for (int i = 0; i < n; i++)
{
    cout << d[i][0];
    for (int j = 1; j < m; j++)
        cout << " " << d[i][j];
    cout << endl;
}

/// up
for (t = n - 1; t >= 0; t--)
{
    long long p;
    cin >> p;

    if (p >= n + 1 && p <= m + n)d[t][n + m - p] = 1;
}

for (int i = 0; i < n; i++)
{
    cout << d[i][0];
    for (int j = 1; j < m; j++)
        cout << " " << d[i][j];
    cout << endl;
}

/// left
for (t = m - 1; t >= 0; t--)
{
    long long p;
    cin >> p;

    if (p >= 0 && p <= n)d[p - 1][t] = 1;
}

for (int i = 0; i < n; i++)
{
    cout << d[i][0];
    for (int j = 1; j < m; j++)
        cout << " " << d[i][j];
    cout << endl;
}*/
